<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="名称" prop="name">
              <el-input v-model="queryParams.name" placeholder="请输入名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="桩号" prop="zh">
              <el-input v-model="queryParams.zh" placeholder="请输入桩号" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="经度" prop="lon">
              <el-input v-model="queryParams.lon" placeholder="请输入经度" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="纬度" prop="lat">
              <el-input v-model="queryParams.lat" placeholder="请输入纬度" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:device:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['system:device:edit']"
              >修改</el-button
            >
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['system:device:remove']"
              >删除</el-button
            >
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="deviceList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编号" align="center" prop="id" />
        <el-table-column label="名称" align="center" show-overflow-tooltip prop="name" />
        <el-table-column label="地址" align="center" show-overflow-tooltip prop="ext1.addr" />
        <el-table-column label="方向" align="center" prop="direction" />
        <el-table-column label="桩号" align="center" prop="zh" />
        <el-table-column label="经度" align="center" prop="lon" />
        <el-table-column label="纬度" align="center" prop="lat" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:device:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:device:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改设备-摄像机对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="600px" append-to-body>
      <el-form ref="deviceFormRef" label-position="top" label-suffix=":" :model="form" label-width="80px">
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="名称" prop="name"> <el-input v-model="form.name" placeholder="请输入名称" /> </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="地址" prop="ext1.addr">
              <el-input v-model="form.ext1.addr" placeholder="请输入地址" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="方向" prop="direction">
              <el-input v-model="form.direction" placeholder="请输入方向" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="桩号" prop="zh">
              <el-input v-model="form.zh" placeholder="请输入桩号" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="视频流地址" prop="ext1.streamUrl">
              <el-input v-model="form.ext1.streamUrl" placeholder="请输入视频流地址" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="位置">
              <div class="map" id="map"></div>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Device" lang="ts">
import { listDevice, getDevice, delDevice, addDevice, updateDevice } from '@/api/system/device';
import { DeviceVO, DeviceForm } from '@/api/system/device/types';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const deviceList = ref<DeviceVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const deviceFormRef = ref<ElFormInstance>();
const bdmap = ref(null);
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
const initFormData = {
  id: undefined,
  name: undefined,
  direction: undefined,
  zh: undefined,
  lon: undefined,
  lat: undefined,
  ext1: {
    addr: undefined
  } as any,
  ext2: undefined
};
const data = reactive({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    name: undefined,
    direction: undefined,
    zh: undefined,
    lon: undefined,
    lat: undefined,
    params: {}
  }
});

const { queryParams, form } = toRefs(data);

/** 查询设备-摄像机列表 */
const getList = async () => {
  loading.value = true;
  const res = await listDevice(queryParams.value);
  deviceList.value = res.rows.map((item) => ({
    ...item,
    ext1: item.ext1 && JSON.parse(item.ext1)
  }));
  total.value = res.total;
  loading.value = false;
};
const initMap = (center) => {
  const [lng, lat] = center || [118.879999, 32.016216];
  const map = new BMapGL.Map('map'); // 创建地图实例
  const point = new BMapGL.Point(lng, lat); // 创建点坐标
  map.centerAndZoom(point, 14);
  map.enableScrollWheelZoom(true);
  bdmap.value = map;
  if (center) {
    drawPoint([lng, lat]);
  }
  map.addEventListener('click', function (e) {
    const { lng, lat } = e.latlng;
    form.value.lon = lng;
    form.value.lat = lat;
    drawPoint([lng, lat]);
  });
};
const drawPoint = (point) => {
  bdmap.value && bdmap.value.clearOverlays();
  const [lng, lat] = point;
  const icon = new BMapGL.Icon(new URL('@/assets/images/monitor.svg', import.meta.url).href, new BMapGL.Size(30, 30));
  const marker = new BMapGL.Marker(new BMapGL.Point(lng, lat), { icon });
  bdmap.value.addOverlay(marker);
};
/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  deviceFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: DeviceVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加设备';
  nextTick(() => {
    initMap(null);
  });
};

/** 修改按钮操作 */
const handleUpdate = async (row?: DeviceVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getDevice(_id);
  res.data.ext1 && (res.data.ext1 = JSON.parse(res.data.ext1));
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改设备';
  nextTick(() => {
    const { lon, lat } = form.value;
    if (lon && lat) {
      initMap([Number(lon), Number(lat)]);
    } else {
      initMap(null);
    }
  });
};

/** 提交按钮 */
const submitForm = () => {
  deviceFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      const params = Object.assign({}, { ...form.value }, { ext1: JSON.stringify(form.value.ext1) });
      if (form.value.id) {
        await updateDevice(params).finally(() => (buttonLoading.value = false));
      } else {
        await addDevice(params).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: DeviceVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除设备？').finally(() => (loading.value = false));
  await delDevice(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

onMounted(() => {
  getList();
});
</script>
<style lang="scss" scoped>
.map {
  width: 100%;
  height: 300px;
}
</style>
